import { EmojiCollection } from "../collections";
/**
 * Emoji Class
 */
export declare class Emoji {
    #private;
    readonly id: string;
    /**
     * Construct Emoji
     * @param collection Collection
     * @param id Emoji Id
     */
    constructor(collection: EmojiCollection, id: string);
    /**
     * Convert to string
     * @returns String
     */
    toString(): string;
    /**
     * Time when this emoji was created
     */
    get createdAt(): Date;
    /**
     * Information about the parent of this emoji
     */
    get parent(): {
        type: "Server";
        id: string;
    } | {
        type: "Detached";
    };
    /**
     * Creator of the emoji
     */
    get creator(): import("./User").User | undefined;
    /**
     * Name
     */
    get name(): string;
    /**
     * Whether the emoji is animated
     */
    get animated(): boolean;
    /**
     * Whether the emoji is marked as mature
     */
    get mature(): boolean;
    /**
     * Delete Emoji
     */
    delete(): Promise<void>;
}
//# sourceMappingURL=Emoji.d.ts.map