import { API, Bot, PublicBot } from "..";
import { HydratedBot } from "../hydration/bot";
import { ClassCollection } from ".";
export declare class BotCollection extends ClassCollection<Bot, HydratedBot> {
    /**
     * Fetch bot by ID
     * @param id Id
     * @returns Bot
     */
    fetch(id: string): Promise<Bot>;
    /**
     * Fetch owned bots
     * @returns List of bots
     */
    fetchOwned(): Promise<Bot[]>;
    /**
     * Fetch public bot by ID
     * @param id Id
     * @returns Public Bot
     */
    fetchPublic(id: string): Promise<PublicBot>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     * @returns Bot
     */
    getOrCreate(id: string, data: API.Bot): Bot;
    /**
     * Create a bot
     * @param name Bot name
     * @returns The newly-created bot
     */
    createBot(name: string): Promise<Bot>;
}
//# sourceMappingURL=BotCollection.d.ts.map