import { API, Emoji } from "..";
import { HydratedEmoji } from "../hydration";
import { ClassCollection } from ".";
export declare class EmojiCollection extends ClassCollection<Emoji, HydratedEmoji> {
    /**
     * Fetch emoji by ID
     * @param id Id
     * @returns Emoji
     */
    fetch(id: string): Promise<Emoji>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     * @param isNew Whether this object is new
     */
    getOrCreate(id: string, data: API.Emoji, isNew?: boolean): Emoji;
    /**
     * Get or return partial
     * @param id Id
     */
    getOrPartial(id: string): Emoji | undefined;
}
//# sourceMappingURL=EmojiCollection.d.ts.map