import { DataCreateServer } from "revolt-api";
import { API, Server } from "..";
import { HydratedServer } from "../hydration";
import { ClassCollection } from ".";
export declare class ServerCollection extends ClassCollection<Server, HydratedServer> {
    /**
     * Fetch server by ID
     *
     * This will not fetch channels!
     * @param id Id
     * @returns Server
     */
    fetch(id: string): Promise<Server>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     * @param isNew Whether this object is new
     */
    getOrCreate(id: string, data: API.Server, isNew?: boolean): Server;
    /**
     * Get or return partial
     * @param id Id
     */
    getOrPartial(id: string): Server | undefined;
    /**
     * Create a server
     * @param data Server options
     * @returns The newly-created server
     */
    createServer(data: DataCreateServer): Promise<Server>;
}
//# sourceMappingURL=ServerCollection.d.ts.map