import { API, ServerMember } from "..";
import { HydratedServerMember } from "../hydration";
import { ClassCollection } from ".";
export declare class ServerMemberCollection extends ClassCollection<ServerMember, HydratedServerMember> {
    /**
     * Check if member exists by composite key
     * @param id Id
     * @returns Whether it exists
     */
    hasByKey(id: API.MemberCompositeKey): boolean;
    /**
     * Get member by composite key
     * @param id Id
     * @returns Member
     */
    getByKey(id: API.MemberCompositeKey): ServerMember | undefined;
    /**
     * Fetch server member by Id
     * @param serverId Server Id
     * @param userId User Id
     * @returns Message
     */
    fetch(serverId: string, userId: string): Promise<ServerMember>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     */
    getOrCreate(id: API.MemberCompositeKey, data: API.Member): ServerMember;
    /**
     * Get or return partial
     * @param id Id
     */
    getOrPartial(id: API.MemberCompositeKey): ServerMember | undefined;
}
//# sourceMappingURL=ServerMemberCollection.d.ts.map