import { API, User } from "..";
import { HydratedUser } from "../hydration";
import { ClassCollection } from ".";
export declare class UserCollection extends ClassCollection<User, HydratedUser> {
    /**
     * Fetch user by ID
     * @param id Id
     * @returns User
     */
    fetch(id: string): Promise<User>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     * @param isNew Whether this object is new
     */
    getOrCreate(id: string, data: API.User): User;
    /**
     * Get or return partial
     * @param id Id
     */
    getOrPartial(id: string): User | undefined;
}
//# sourceMappingURL=UserCollection.d.ts.map