import type { Member as ApiMember, MemberCompositeKey } from "revolt-api";
import { Client } from "../Client";
import { HydratedServerMember } from "../hydration/serverMember";
import { ObjectStorage } from "../storage/ObjectStorage";
/**
 * Deterministic conversion of member composite key to string ID
 * @param key Key
 * @returns String key
 */
declare function key(key: MemberCompositeKey): string;
declare const _default: (client: Client) => {
    new (id: MemberCompositeKey, data?: ApiMember): {
        readonly id: MemberCompositeKey;
        /**
         * Server this member belongs to
         */
        readonly server: {
            readonly id: string;
            readonly createdAt: Date;
            readonly owner: {
                readonly id: string;
                readonly createdAt: Date;
                readonly username: string;
                readonly avatar: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined; /**
                 * Construct Member
                 * @param id Member ID
                 */
                readonly badges: import("../hydration/user").UserBadges;
                readonly status: {
                    text?: string | null | undefined;
                    presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                } | undefined;
                readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                readonly online: boolean;
                readonly privileged: boolean;
                readonly flags: import("../hydration/user").UserFlags;
                readonly bot: {
                    owner: string;
                } | undefined;
            } | undefined;
            readonly name: string;
            readonly description: string | undefined;
            readonly icon: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly banner: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly channels: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            }[];
            readonly categories: {
                id: string;
                title: string;
                channels: string[];
            }[] | undefined;
            readonly systemMessages: {
                user_joined?: string | null | undefined;
                user_left?: string | null | undefined;
                user_kicked?: string | null | undefined;
                user_banned?: string | null | undefined;
            } | undefined;
            readonly roles: import("@solid-primitives/map").ReactiveMap<string, {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
            }> | undefined;
            readonly defaultPermissions: number;
            readonly flags: import("../hydration/server").ServerFlags;
            readonly analytics: boolean;
            readonly discoverable: boolean;
            readonly mature: boolean;
            readonly orderedChannels: (Omit<{
                id: string;
                title: string;
                channels: string[];
            }, "channels"> & {
                channels: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                    readonly name: string;
                    readonly description: string | undefined;
                    readonly icon: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined;
                    readonly active: boolean;
                    readonly recipients: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    }[];
                    readonly user: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly owner: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly server: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly permissions: number | undefined;
                    readonly defaultPermissions: {
                        a: number;
                        d: number;
                    } | undefined;
                    readonly rolePermissions: Record<string, {
                        a: number;
                        d: number;
                    }> | undefined;
                    readonly mature: boolean;
                    readonly lastMessageId: string | undefined;
                }[];
            })[];
            readonly defaultChannel: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            } | undefined;
            readonly orderedRoles: {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
                id: string;
            }[];
        } | undefined;
        /**
         * User corresponding to this member
         */
        readonly user: {
            readonly id: string;
            readonly createdAt: Date;
            readonly username: string;
            readonly avatar: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined; /**
             * Construct Member
             * @param id Member ID
             */
            readonly badges: import("../hydration/user").UserBadges;
            readonly status: {
                text?: string | null | undefined;
                presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
            } | undefined;
            readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
            readonly online: boolean;
            readonly privileged: boolean;
            readonly flags: import("../hydration/user").UserFlags;
            readonly bot: {
                owner: string;
            } | undefined;
        } | undefined;
        /**
         * When this user joined the server
         */
        readonly joinedAt: Date;
        /**
         * Nickname
         */
        readonly nickname: string | undefined;
        /**
         * Avatar
         */
        readonly avatar: {
            _id: string;
            tag: string;
            filename: string;
            metadata: {
                type: "File";
            } | {
                type: "Text";
            } | {
                type: "Image";
                width: number;
                height: number;
            } | {
                type: "Video";
                width: number;
                height: number;
            } | {
                type: "Audio";
            };
            content_type: string;
            size: number;
            deleted?: boolean | null | undefined;
            reported?: boolean | null | undefined;
            message_id?: string | null | undefined;
            user_id?: string | null | undefined;
            server_id?: string | null | undefined;
            object_id?: string | null | undefined;
        } | undefined;
        /**
         * List of role IDs
         */
        readonly roles: string[] | undefined;
        /**
         * Time at which timeout expires
         */
        readonly timeout: Date | undefined;
    };
    "__#8@#storage": ObjectStorage<HydratedServerMember>;
    "__#8@#objects": Record<string, {
        readonly id: MemberCompositeKey;
        /**
         * Server this member belongs to
         */
        readonly server: {
            readonly id: string;
            readonly createdAt: Date;
            readonly owner: {
                readonly id: string;
                readonly createdAt: Date;
                readonly username: string;
                readonly avatar: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined; /**
                 * Construct Member
                 * @param id Member ID
                 */
                readonly badges: import("../hydration/user").UserBadges;
                readonly status: {
                    text?: string | null | undefined;
                    presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                } | undefined;
                readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                readonly online: boolean;
                readonly privileged: boolean;
                readonly flags: import("../hydration/user").UserFlags;
                readonly bot: {
                    owner: string;
                } | undefined;
            } | undefined;
            readonly name: string;
            readonly description: string | undefined;
            readonly icon: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly banner: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly channels: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            }[];
            readonly categories: {
                id: string;
                title: string;
                channels: string[];
            }[] | undefined;
            readonly systemMessages: {
                user_joined?: string | null | undefined;
                user_left?: string | null | undefined;
                user_kicked?: string | null | undefined;
                user_banned?: string | null | undefined;
            } | undefined;
            readonly roles: import("@solid-primitives/map").ReactiveMap<string, {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
            }> | undefined;
            readonly defaultPermissions: number;
            readonly flags: import("../hydration/server").ServerFlags;
            readonly analytics: boolean;
            readonly discoverable: boolean;
            readonly mature: boolean;
            readonly orderedChannels: (Omit<{
                id: string;
                title: string;
                channels: string[];
            }, "channels"> & {
                channels: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                    readonly name: string;
                    readonly description: string | undefined;
                    readonly icon: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined;
                    readonly active: boolean;
                    readonly recipients: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    }[];
                    readonly user: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly owner: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly server: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly permissions: number | undefined;
                    readonly defaultPermissions: {
                        a: number;
                        d: number;
                    } | undefined;
                    readonly rolePermissions: Record<string, {
                        a: number;
                        d: number;
                    }> | undefined;
                    readonly mature: boolean;
                    readonly lastMessageId: string | undefined;
                }[];
            })[];
            readonly defaultChannel: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            } | undefined;
            readonly orderedRoles: {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
                id: string;
            }[];
        } | undefined;
        /**
         * User corresponding to this member
         */
        readonly user: {
            readonly id: string;
            readonly createdAt: Date;
            readonly username: string;
            readonly avatar: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined; /**
             * Construct Member
             * @param id Member ID
             */
            readonly badges: import("../hydration/user").UserBadges;
            readonly status: {
                text?: string | null | undefined;
                presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
            } | undefined;
            readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
            readonly online: boolean;
            readonly privileged: boolean;
            readonly flags: import("../hydration/user").UserFlags;
            readonly bot: {
                owner: string;
            } | undefined;
        } | undefined;
        /**
         * When this user joined the server
         */
        readonly joinedAt: Date;
        /**
         * Nickname
         */
        readonly nickname: string | undefined;
        /**
         * Avatar
         */
        readonly avatar: {
            _id: string;
            tag: string;
            filename: string;
            metadata: {
                type: "File";
            } | {
                type: "Text";
            } | {
                type: "Image";
                width: number;
                height: number;
            } | {
                type: "Video";
                width: number;
                height: number;
            } | {
                type: "Audio";
            };
            content_type: string;
            size: number;
            deleted?: boolean | null | undefined;
            reported?: boolean | null | undefined;
            message_id?: string | null | undefined;
            user_id?: string | null | undefined;
            server_id?: string | null | undefined;
            object_id?: string | null | undefined;
        } | undefined;
        /**
         * List of role IDs
         */
        readonly roles: string[] | undefined;
        /**
         * Time at which timeout expires
         */
        readonly timeout: Date | undefined;
    }>;
    /**
     * Deterministic conversion of member composite key to string ID
     * @param key Key
     * @returns String key
     */
    keyToString: typeof key;
    /**
     * Get an existing Member
     * @param id Member ID
     * @returns Member
     */
    get(id: MemberCompositeKey): {
        readonly id: MemberCompositeKey;
        /**
         * Server this member belongs to
         */
        readonly server: {
            readonly id: string;
            readonly createdAt: Date;
            readonly owner: {
                readonly id: string;
                readonly createdAt: Date;
                readonly username: string;
                readonly avatar: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined; /**
                 * Construct Member
                 * @param id Member ID
                 */
                readonly badges: import("../hydration/user").UserBadges;
                readonly status: {
                    text?: string | null | undefined;
                    presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                } | undefined;
                readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                readonly online: boolean;
                readonly privileged: boolean;
                readonly flags: import("../hydration/user").UserFlags;
                readonly bot: {
                    owner: string;
                } | undefined;
            } | undefined;
            readonly name: string;
            readonly description: string | undefined;
            readonly icon: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly banner: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly channels: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            }[];
            readonly categories: {
                id: string;
                title: string;
                channels: string[];
            }[] | undefined;
            readonly systemMessages: {
                user_joined?: string | null | undefined;
                user_left?: string | null | undefined;
                user_kicked?: string | null | undefined;
                user_banned?: string | null | undefined;
            } | undefined;
            readonly roles: import("@solid-primitives/map").ReactiveMap<string, {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
            }> | undefined;
            readonly defaultPermissions: number;
            readonly flags: import("../hydration/server").ServerFlags;
            readonly analytics: boolean;
            readonly discoverable: boolean;
            readonly mature: boolean;
            readonly orderedChannels: (Omit<{
                id: string;
                title: string;
                channels: string[];
            }, "channels"> & {
                channels: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                    readonly name: string;
                    readonly description: string | undefined;
                    readonly icon: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined;
                    readonly active: boolean;
                    readonly recipients: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    }[];
                    readonly user: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly owner: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly server: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly permissions: number | undefined;
                    readonly defaultPermissions: {
                        a: number;
                        d: number;
                    } | undefined;
                    readonly rolePermissions: Record<string, {
                        a: number;
                        d: number;
                    }> | undefined;
                    readonly mature: boolean;
                    readonly lastMessageId: string | undefined;
                }[];
            })[];
            readonly defaultChannel: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            } | undefined;
            readonly orderedRoles: {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
                id: string;
            }[];
        } | undefined;
        /**
         * User corresponding to this member
         */
        readonly user: {
            readonly id: string;
            readonly createdAt: Date;
            readonly username: string;
            readonly avatar: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined; /**
             * Construct Member
             * @param id Member ID
             */
            readonly badges: import("../hydration/user").UserBadges;
            readonly status: {
                text?: string | null | undefined;
                presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
            } | undefined;
            readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
            readonly online: boolean;
            readonly privileged: boolean;
            readonly flags: import("../hydration/user").UserFlags;
            readonly bot: {
                owner: string;
            } | undefined;
        } | undefined;
        /**
         * When this user joined the server
         */
        readonly joinedAt: Date;
        /**
         * Nickname
         */
        readonly nickname: string | undefined;
        /**
         * Avatar
         */
        readonly avatar: {
            _id: string;
            tag: string;
            filename: string;
            metadata: {
                type: "File";
            } | {
                type: "Text";
            } | {
                type: "Image";
                width: number;
                height: number;
            } | {
                type: "Video";
                width: number;
                height: number;
            } | {
                type: "Audio";
            };
            content_type: string;
            size: number;
            deleted?: boolean | null | undefined;
            reported?: boolean | null | undefined;
            message_id?: string | null | undefined;
            user_id?: string | null | undefined;
            server_id?: string | null | undefined;
            object_id?: string | null | undefined;
        } | undefined;
        /**
         * List of role IDs
         */
        readonly roles: string[] | undefined;
        /**
         * Time at which timeout expires
         */
        readonly timeout: Date | undefined;
    } | undefined;
    /**
     * Fetch member by ID
     * @param id Member ID
     * @returns Member
     */
    fetch(id: MemberCompositeKey): Promise<{
        readonly id: MemberCompositeKey;
        /**
         * Server this member belongs to
         */
        readonly server: {
            readonly id: string;
            readonly createdAt: Date;
            readonly owner: {
                readonly id: string;
                readonly createdAt: Date;
                readonly username: string;
                readonly avatar: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined; /**
                 * Construct Member
                 * @param id Member ID
                 */
                readonly badges: import("../hydration/user").UserBadges;
                readonly status: {
                    text?: string | null | undefined;
                    presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                } | undefined;
                readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                readonly online: boolean;
                readonly privileged: boolean;
                readonly flags: import("../hydration/user").UserFlags;
                readonly bot: {
                    owner: string;
                } | undefined;
            } | undefined;
            readonly name: string;
            readonly description: string | undefined;
            readonly icon: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly banner: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined;
            readonly channels: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            }[];
            readonly categories: {
                id: string;
                title: string;
                channels: string[];
            }[] | undefined;
            readonly systemMessages: {
                user_joined?: string | null | undefined;
                user_left?: string | null | undefined;
                user_kicked?: string | null | undefined;
                user_banned?: string | null | undefined;
            } | undefined;
            readonly roles: import("@solid-primitives/map").ReactiveMap<string, {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
            }> | undefined;
            readonly defaultPermissions: number;
            readonly flags: import("../hydration/server").ServerFlags;
            readonly analytics: boolean;
            readonly discoverable: boolean;
            readonly mature: boolean;
            readonly orderedChannels: (Omit<{
                id: string;
                title: string;
                channels: string[];
            }, "channels"> & {
                channels: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                    readonly name: string;
                    readonly description: string | undefined;
                    readonly icon: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined;
                    readonly active: boolean;
                    readonly recipients: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    }[];
                    readonly user: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly owner: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly server: {
                        readonly id: string;
                        readonly createdAt: Date;
                        readonly username: string;
                        readonly avatar: {
                            _id: string;
                            tag: string;
                            filename: string;
                            metadata: {
                                type: "File";
                            } | {
                                type: "Text";
                            } | {
                                type: "Image";
                                width: number;
                                height: number;
                            } | {
                                type: "Video";
                                width: number;
                                height: number;
                            } | {
                                type: "Audio";
                            };
                            content_type: string;
                            size: number;
                            deleted?: boolean | null | undefined;
                            reported?: boolean | null | undefined;
                            message_id?: string | null | undefined;
                            user_id?: string | null | undefined;
                            server_id?: string | null | undefined;
                            object_id?: string | null | undefined;
                        } | undefined; /**
                         * Construct Member
                         * @param id Member ID
                         */
                        readonly badges: import("../hydration/user").UserBadges;
                        readonly status: {
                            text?: string | null | undefined;
                            presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                        } | undefined;
                        readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                        readonly online: boolean;
                        readonly privileged: boolean;
                        readonly flags: import("../hydration/user").UserFlags;
                        readonly bot: {
                            owner: string;
                        } | undefined;
                    } | undefined;
                    readonly permissions: number | undefined;
                    readonly defaultPermissions: {
                        a: number;
                        d: number;
                    } | undefined;
                    readonly rolePermissions: Record<string, {
                        a: number;
                        d: number;
                    }> | undefined;
                    readonly mature: boolean;
                    readonly lastMessageId: string | undefined;
                }[];
            })[];
            readonly defaultChannel: {
                readonly id: string;
                readonly createdAt: Date;
                readonly type: "SavedMessages" | "DirectMessage" | "Group" | "TextChannel" | "VoiceChannel";
                readonly name: string;
                readonly description: string | undefined;
                readonly icon: {
                    _id: string;
                    tag: string;
                    filename: string;
                    metadata: {
                        type: "File";
                    } | {
                        type: "Text";
                    } | {
                        type: "Image";
                        width: number;
                        height: number;
                    } | {
                        type: "Video";
                        width: number;
                        height: number;
                    } | {
                        type: "Audio";
                    };
                    content_type: string;
                    size: number;
                    deleted?: boolean | null | undefined;
                    reported?: boolean | null | undefined;
                    message_id?: string | null | undefined;
                    user_id?: string | null | undefined;
                    server_id?: string | null | undefined;
                    object_id?: string | null | undefined;
                } | undefined;
                readonly active: boolean;
                readonly recipients: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                }[];
                readonly user: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly owner: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly server: {
                    readonly id: string;
                    readonly createdAt: Date;
                    readonly username: string;
                    readonly avatar: {
                        _id: string;
                        tag: string;
                        filename: string;
                        metadata: {
                            type: "File";
                        } | {
                            type: "Text";
                        } | {
                            type: "Image";
                            width: number;
                            height: number;
                        } | {
                            type: "Video";
                            width: number;
                            height: number;
                        } | {
                            type: "Audio";
                        };
                        content_type: string;
                        size: number;
                        deleted?: boolean | null | undefined;
                        reported?: boolean | null | undefined;
                        message_id?: string | null | undefined;
                        user_id?: string | null | undefined;
                        server_id?: string | null | undefined;
                        object_id?: string | null | undefined;
                    } | undefined; /**
                     * Construct Member
                     * @param id Member ID
                     */
                    readonly badges: import("../hydration/user").UserBadges;
                    readonly status: {
                        text?: string | null | undefined;
                        presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
                    } | undefined;
                    readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
                    readonly online: boolean;
                    readonly privileged: boolean;
                    readonly flags: import("../hydration/user").UserFlags;
                    readonly bot: {
                        owner: string;
                    } | undefined;
                } | undefined;
                readonly permissions: number | undefined;
                readonly defaultPermissions: {
                    a: number;
                    d: number;
                } | undefined;
                readonly rolePermissions: Record<string, {
                    a: number;
                    d: number;
                }> | undefined;
                readonly mature: boolean;
                readonly lastMessageId: string | undefined;
            } | undefined;
            readonly orderedRoles: {
                name: string;
                permissions: {
                    a: number;
                    d: number;
                };
                colour?: string | null | undefined;
                hoist?: boolean | undefined;
                rank?: number | undefined;
                id: string;
            }[];
        } | undefined;
        /**
         * User corresponding to this member
         */
        readonly user: {
            readonly id: string;
            readonly createdAt: Date;
            readonly username: string;
            readonly avatar: {
                _id: string;
                tag: string;
                filename: string;
                metadata: {
                    type: "File";
                } | {
                    type: "Text";
                } | {
                    type: "Image";
                    width: number;
                    height: number;
                } | {
                    type: "Video";
                    width: number;
                    height: number;
                } | {
                    type: "Audio";
                };
                content_type: string;
                size: number;
                deleted?: boolean | null | undefined;
                reported?: boolean | null | undefined;
                message_id?: string | null | undefined;
                user_id?: string | null | undefined;
                server_id?: string | null | undefined;
                object_id?: string | null | undefined;
            } | undefined; /**
             * Construct Member
             * @param id Member ID
             */
            readonly badges: import("../hydration/user").UserBadges;
            readonly status: {
                text?: string | null | undefined;
                presence?: "Online" | "Idle" | "Focus" | "Busy" | "Invisible" | null | undefined;
            } | undefined;
            readonly relationship: "None" | "User" | "Friend" | "Outgoing" | "Incoming" | "Blocked" | "BlockedOther";
            readonly online: boolean;
            readonly privileged: boolean;
            readonly flags: import("../hydration/user").UserFlags;
            readonly bot: {
                owner: string;
            } | undefined;
        } | undefined;
        /**
         * When this user joined the server
         */
        readonly joinedAt: Date;
        /**
         * Nickname
         */
        readonly nickname: string | undefined;
        /**
         * Avatar
         */
        readonly avatar: {
            _id: string;
            tag: string;
            filename: string;
            metadata: {
                type: "File";
            } | {
                type: "Text";
            } | {
                type: "Image";
                width: number;
                height: number;
            } | {
                type: "Video";
                width: number;
                height: number;
            } | {
                type: "Audio";
            };
            content_type: string;
            size: number;
            deleted?: boolean | null | undefined;
            reported?: boolean | null | undefined;
            message_id?: string | null | undefined;
            user_id?: string | null | undefined;
            server_id?: string | null | undefined;
            object_id?: string | null | undefined;
        } | undefined;
        /**
         * List of role IDs
         */
        readonly roles: string[] | undefined;
        /**
         * Time at which timeout expires
         */
        readonly timeout: Date | undefined;
    } | undefined>;
};
export default _default;
//# sourceMappingURL=ServerMember.d.ts.map