import { ReactiveMap } from "@solid-primitives/map";
import { ReactiveSet } from "@solid-primitives/set";
import { Server as ApiServer, Category, File, Role, SystemMessageChannels } from "revolt-api";
import { Hydrate } from ".";
export type HydratedServer = {
    id: string;
    ownerId: string;
    name: string;
    description?: string;
    icon?: File;
    banner?: File;
    channelIds: ReactiveSet<string>;
    categories?: Category[];
    systemMessages?: SystemMessageChannels;
    roles?: ReactiveMap<string, Role>;
    defaultPermissions: number;
    flags: ServerFlags;
    analytics: boolean;
    discoverable: boolean;
    nsfw: boolean;
};
export declare const serverHydration: Hydrate<ApiServer, HydratedServer>;
/**
 * Flags attributed to servers
 */
export declare enum ServerFlags {
    Official = 1,
    Verified = 2
}
//# sourceMappingURL=server.d.ts.map