import { User as ApiUser, BotInformation, File, RelationshipStatus, UserStatus } from "revolt-api";
import { Hydrate } from ".";
export type HydratedUser = {
    id: string;
    username: string;
    relationship: RelationshipStatus;
    online: boolean;
    privileged: boolean;
    badges: UserBadges;
    flags: UserFlags;
    avatar?: File;
    status?: UserStatus;
    bot?: BotInformation;
};
export declare const userHydration: Hydrate<ApiUser, HydratedUser>;
/**
 * Badges available to users
 */
export declare enum UserBadges {
    Developer = 1,
    Translator = 2,
    Supporter = 4,
    ResponsibleDisclosure = 8,
    Founder = 16,
    PlatformModeration = 32,
    ActiveSupporter = 64,
    Paw = 128,
    EarlyAdopter = 256,
    ReservedRelevantJokeBadge1 = 512,
    ReservedRelevantJokeBadge2 = 1024
}
/**
 * Flags attributed to users
 */
export declare enum UserFlags {
    Suspended = 1,
    Deleted = 2,
    Banned = 4
}
//# sourceMappingURL=user.d.ts.map