import { SetStoreFunction } from "solid-js/store";
import { Hydrators } from "../hydration";
/**
 * Wrapper around Solid.js store
 */
export declare class ObjectStorage<T> {
    private store;
    readonly set: SetStoreFunction<Record<string, T>>;
    /**
     * Create new object storage
     */
    constructor();
    /**
     * Get object by ID
     * @param id ID
     * @returns Object
     */
    get(id: string): T;
    /**
     * Hydrate some data into storage
     * @param id ID
     * @param type Hydration type
     * @param data Input Data
     */
    hydrate(id: string, type: keyof Hydrators, data?: unknown): void;
}
//# sourceMappingURL=ObjectStorage.d.ts.map